//: Playground - noun: a place where people can play

import UIKit

// Definition einer Funktion
func addieren(wert1:Double, wert2:Double) -> Double
{
    return wert1 + wert2
}

// Aufruf der Funktion
let ergebnis = addieren(wert1: 6.87, wert2: 11.29)

// Definition einer Closure mit einer expliziten
// Angabe von Parameter und Rückgabetyp
let meineClosure:((Double, Double) -> Double) = {
    (wert1:Double, wert2:Double) -> Double in
    return wert1 + wert2
}

// Aufruf der Closure
let ergebnis2 = meineClosure(6.87, 11.29)

// Funktion zur Erzeugung einer Liste von Zufallszahlen
func erzeugeZufallszahlen
    (anzahl:Int, aktion:([Int]) -> () )
{
    var zahlen = [Int]()
    
    // Zufallszahlen zwischen 0 und 199 generieren
    for _ in 1...anzahl
    {
        let zahl = Int(arc4random_uniform(200))
        zahlen.append(zahl)
    }
    
    // Die Closure aufrufen
    aktion(zahlen)
}

// Definition einer Closure, die ein Integer-Array
// entgegennimmt und keinen Wert zurückgibt
var ausgabe = {
    (werte:[Int]) -> () in
    for wert in werte
    {
        print("Zahl: \(wert)")
    }
    
    print("Der erste Wert ist: \(werte.first!)")
    print("Der letzte Wert ist: \(werte.last!)")
}

// Funktion mit der Anzahl der Zufallszahlen
// und der Closure als Parameter aufrufen
erzeugeZufallszahlen(anzahl:5, aktion: ausgabe)


// Definition einer Closure zum
// Anhängen von Nachnamen an die Vornamen
let nachnameAnhaengen =
{
    (name:String) -> (String) in
    "\(name) Müller"
}

var familie = ["Stefanie", "Marika", "Jan", "Peter", "Sabine"]

// Alle Elemente aus dem Array ansprechen
// mit der map-Methode
familie = familie.map(nachnameAnhaengen)

// Closure einer Closure als Inline-Syntax
/*
familie = familie.map (
    {
        (name:String) -> (String) in
        "\(name) Müller"
    })
*/

familie = familie.map()
{
        (name:String) -> (String) in
        "\(name) Müller"
}


// Aufruf der Funktion mit einer Inline-Closure
erzeugeZufallszahlen(anzahl:5)
{
    (werte:[Int]) -> () in
    for wert in werte
    {
        print("Zahl: \(wert)")
    }
    
    print("Der erste Wert ist: \(werte.first!)")
    print("Der letzte Wert ist: \(werte.last!)")
}

// Variablen werden außerhalb der Closure definiert
var zahl1 = 10
var zahl2 = 20

var einfangen =
{
    () -> () in
    print("Aufruf in der Closure:")
    print("zahl1 ist \(zahl1) und zahl2 ist \(zahl2).")
    // Der Wert der Variablen wird geändert
    zahl1 = 100
}

// Nach der Definition der Closure werden den
// Variablen neue Werte zugewiesen
zahl1 = 99
zahl2 = 98

print("Vor dem Aufruf der Closure:")
print("zahl1 ist \(zahl1) und zahl2 ist \(zahl2).")

einfangen()

print("Nach dem Aufruf der Closure:")
print("zahl1 ist \(zahl1) und zahl2 ist \(zahl2).")


























